> ## Documentation Index
> Fetch the complete documentation index at: https://conductorone-docs-iga-1271.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Set up a Dropbox connector

> ConductorOne provides identity governance and just-in-time provisioning for Dropbox. Integrate your Dropbox HCM instance with ConductorOne to run user access reviews (UARs) and enable just-in-time access requests.

## Capabilities

| Resource | Sync                                                          | Provision                                                     |
| :------- | :------------------------------------------------------------ | :------------------------------------------------------------ |
| Accounts | <Icon icon="square-check" iconType="solid" color="#65DE23" /> | <Icon icon="square-check" iconType="solid" color="#65DE23" /> |
| Roles    | <Icon icon="square-check" iconType="solid" color="#65DE23" /> | <Icon icon="square-check" iconType="solid" color="#65DE23" /> |
| Groups   | <Icon icon="square-check" iconType="solid" color="#65DE23" /> | <Icon icon="square-check" iconType="solid" color="#65DE23" /> |

The Dropbox connector supports [automatic account provisioning and deprovisioning](/product/admin/account-provisioning).

### Connector actions

Connector actions are custom capabilities that extend ConductorOne automations with app-specific operations. You can use connector actions in the [Perform connector action](/product/admin/automations-steps-reference#perform-connector-action) automation step.

| Action name   | Additional fields            | Description                                                      |
| ------------- | ---------------------------- | ---------------------------------------------------------------- |
| enable\_user  | `user_id` (string, required) | Enables a user's access to Dropbox Team (unsuspends the account) |
| disable\_user | `user_id` (string, required) | Disables a user's access to Dropbox Team (suspends the account)  |

<Warning>
  Disabling a Dropbox account will wipe the account's data on linked devices. Ensure this behavior is acceptable before running the action.
</Warning>

## Gather Dropbox credentials

Configuring the connector requires you to pass in credentials for Dropbox. Gather these credentials before you move on.

<Warning>
  A user with the **Team Admin** role in Dropbox must perform this task.
</Warning>

### Create a Dropbox app

<Steps>
  <Step>
    In Dropbox, navigate to the Dropbox App Console.
  </Step>

  <Step>
    Click **Create app**.
  </Step>

  <Step>
    Select **Scoped access**.
  </Step>

  <Step>
    Choose the **Full Dropbox** access type.
  </Step>

  <Step>
    Select **Team** as the access type.
  </Step>

  <Step>
    Give the new app a name, such as "ConductorOne".
  </Step>

  <Step>
    Click **Create app**.
  </Step>
</Steps>

### Save app credentials and set permissions

<Steps>
  <Step>
    Navigate to the app's **Settings** tab.
  </Step>

  <Step>
    Carefully copy and save the app key and app secret.
  </Step>

  <Step>
    Give the app the relevant set of permissions:

    For syncing (read-only) operations:

    * team\_data.member - Read user information and profiles
    * team\_data.governance - Read role definitions and assignments
    * team\_info.read - Read team structure and groups

    For provisioning (read-write) operations:

    * team\_data.member - Read user information and profiles
    * team\_data.governance - Read role definitions and assignments
    * team\_info.read - Read team structure and groups
    * members.write - Create new team members and suspend/unsuspend accounts
    * members.delete - Remove team members from the organization
    * groups.write - Add/remove users from groups
  </Step>

  <Step>
    Click **Submit** to save the permissions.
  </Step>
</Steps>

### Self-hosted only: Get a Dropbox refresh token

This section is only required if you're setting up a self-hosted Dropbox connector.

<Steps>
  <Step>
    First, run the following to get a short-lived access code for the Dropbox API, pasting in your app's key:

    ```bash theme={null}
    https://www.dropbox.com/oauth2/authorize?client_id=<APP_KEY>&token_access_type=offline&response_type=code
    ```
  </Step>

  <Step>
    Then, run the following, pasting in the access code along with your app's key and secret, to generate a refresh token:

    ```bash theme={null}
    curl --location --request POST 'https://api.dropboxapi.com/oauth2/token' \
    -u '<APP_KEY>:<APP_SECRET>'
    -H 'Content-Type: application/x-www-form-urlencoded' \
    --data-urlencode 'code=<ACCESS_CODE>' \
    --data-urlencode 'grant_type=authorization_code'
    ```
  </Step>

  <Step>
    Carefully copy and save the refresh token.
  </Step>
</Steps>

**That's it!** Next, move on to the connector configuration instructions.

## Configure the Dropbox connector

<Warning>
  To complete this task, you'll need:

  * The **Connector Administrator** or **Super Administrator** role in ConductorOne
  * The **Admin** role in Dropbox
</Warning>

<Tabs>
  <Tab title="Cloud-hosted">
    **Follow these instructions to use a built-in, no-code connector hosted by ConductorOne.**

    <Steps>
      <Step>
        In ConductorOne, navigate to **Integrations** > **Connectors** and click **Add connector**.
      </Step>

      <Step>
        Search for **Dropbox** and click **Add**.
      </Step>

      <Step>
        Choose how to set up the new Dropbox connector:

        * Add the connector to a currently unmanaged app (select from the list of apps that were discovered in your identity, SSO, or federation provider that aren't yet managed with ConductorOne)
        * Add the connector to a managed app (select from the list of existing managed apps)
        * Create a new managed app
      </Step>

      <Step>
        Set the owner for this connector. You can manage the connector yourself, or choose someone else from the list of ConductorOne users. Setting multiple owners is allowed.

        If you choose someone else, ConductorOne will notify the new connector owner by email that their help is needed to complete the setup process.
      </Step>

      <Step>
        Click **Next**.
      </Step>

      <Step>
        Find the **Settings** area of the page and click **Edit**.
      </Step>

      <Step>
        Enter the app key and app secret into their respective fields.
      </Step>

      <Step>
        Click **Save**.
      </Step>

      <Step>
        Click **Login with OAuth**.
      </Step>

      <Step>
        Log in and authorize ConductorOne with your Dropbox instance.
      </Step>

      <Step>
        After authorizing, you'll be redirected back to the ConductorOne integrations page, where an "Authorized as" message is now printed.
      </Step>

      <Step>
        The connector's label changes to **Syncing**, followed by **Connected**. You can view the logs to ensure that information is syncing.
      </Step>
    </Steps>

    **That's it!** Your Dropbox connector is now pulling access data into ConductorOne.
  </Tab>

  <Tab title="Self-hosted">
    **Follow these instructions to use the Dropbox connector, hosted and run in your own environment.**

    When running in service mode on Kubernetes, a self-hosted connector maintains an ongoing connection with ConductorOne, automatically syncing and uploading data at regular intervals. This data is immediately available in the ConductorOne UI for access reviews and access requests.

    ### Resources

    * [Official download center](https://dist.conductorone.com/ConductorOne/baton-dropbox): For stable binaries (Windows/Linux/macOS) and container images.

    * [GitHub repository](https://github.com/ConductorOne/baton-dropbox): Access the source code, report issues, or contribute to the project.

    ### Step 1: Set up a new Dropbox connector

    <Steps>
      <Step>
        In ConductorOne, navigate to **Integrations** > **Connectors** > **Add connector**.
      </Step>

      <Step>
        Search for **Baton** and click **Add**.
      </Step>

      <Step>
        Choose how to set up the new Dropbox connector:

        * Add the connector to a currently unmanaged app (select from the list of apps that were discovered in your identity, SSO, or federation provider that aren't yet managed with ConductorOne)
        * Add the connector to a managed app (select from the list of existing managed apps)
        * Create a new managed app
      </Step>

      <Step>
        Set the owner for this connector. You can manage the connector yourself, or choose someone else from the list of ConductorOne users. Setting multiple owners is allowed.

        If you choose someone else, ConductorOne will notify the new connector owner by email that their help is needed to complete the setup process.
      </Step>

      <Step>
        Click **Next**.
      </Step>

      <Step>
        In the **Settings** area of the page, click **Edit**.
      </Step>

      <Step>
        Click **Rotate** to generate a new Client ID and Secret.

        Carefully copy and save these credentials. We'll use them in Step 2.
      </Step>
    </Steps>

    ### Step 2: Create Kubernetes configuration files

    Create two Kubernetes manifest files for your Dropbox connector deployment:

    #### Secrets configuration

    ```yaml expandable theme={null}
    # baton-dropbox-secrets.yaml
    apiVersion: v1
    kind: Secret
    metadata:
      name: baton-dropbox-secrets
    type: Opaque
    stringData:
      # ConductorOne credentials
      BATON_CLIENT_ID: <ConductorOne client ID>
      BATON_CLIENT_SECRET: <ConductorOne client secret>
      
      # Dropbox credentials
      BATON_APP_KEY: <Dropbox app key>
      BATON_APP_SECRET: <Dropbox app secret>
      BATON_REFRESH_TOKEN: <Dropbox refresh token>

      # Optional: include if you want ConductorOne to provision access using this connector
      BATON_PROVISIONING: true
    ```

    See the connector's README or run `--help` to see all available configuration flags and environment variables.

    #### Deployment configuration

    ```yaml expandable theme={null}
    # baton-dropbox.yaml
    apiVersion: apps/v1
    kind: Deployment
    metadata:
      name: baton-dropbox
      labels:
        app: baton-dropbox
    spec:
      selector:
        matchLabels:
          app: baton-dropbox
      template:
        metadata:
          labels:
            app: baton-dropbox
            baton: true
            baton-app: dropbox
        spec:
          containers:
          - name: baton-dropbox
            image: ghcr.io/conductorone/baton-dropbox:latest
            imagePullPolicy: IfNotPresent
            env:
            - name: BATON_HOST_ID
              value: baton-dropbox
            envFrom:
            - secretRef:
                name: baton-dropbox-secrets
    ```

    ### Step 3: Deploy the connector

    <Steps>
      <Step>
        Create a namespace in which to run ConductorOne connectors (if desired), then apply the secret config and deployment config files.
      </Step>

      <Step>
        Check that the connector data uploaded correctly. In ConductorOne, click **Apps**. On the **Managed apps** tab, locate and click the name of the application you added the Dropbox connector to. Dropbox data should be found on the **Entitlements** and **Accounts** tabs.
      </Step>
    </Steps>

    **That's it!** Your Dropbox connector is now pulling access data into ConductorOne.
  </Tab>
</Tabs>
